 ! --------------------------------------------------------------------
program maketestdata
 ! --------------------------------------------------------------------
 ! generate test images

 use dal
 use types
 implicit none 

  type(DataSetT)        :: myset
  type(ArrayT)          :: myarray
  integer, parameter    :: ndata=10
  integer :: i_seed
  real(single), pointer :: pp(:,:), weight(:,:)
  integer(int32), pointer ::  bad(:,:)
  integer(int32), allocatable, dimension(:) :: seed

  myset = dataSet('testConversionImages.dal', create) 

  ! ------------- images ----------

  ! peak at center
  myarray = addArray(myset, 'test', real32, (/ ndata, ndata+1/) )
  pp => real32Array2Data(myarray)
  call random_seed(size=i_seed)
  allocate(seed(1:i_seed))
  call random_seed(put=seed)
  deallocate(seed)
  call random_number(pp)          ! random data
  call release(myarray)


  ! ------------- badpix ----------
  !  row col bad
  myarray = addArray(myset, 'test_badpix', integer32, (/ndata, ndata+1/) )
  bad => int32Array2Data(myarray)
  bad = 0                      ! all data points good
  bad(1,:) = 1                 ! row bad    
  bad(:,2) = 1                 ! col bad    
  call release(myarray)

  ! ------------- weight ----------

  ! constant sigma array
  myarray = addArray(myset, 'test_weight', real32, (/ndata, ndata+1/) )
  weight => real32Array2Data(myarray)
  call random_number(weight)          ! random data           
  call release(myarray)

  ! -----------------------------------------------------------  

  call release(myset)

end program
